unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls;

type
  TIPluginDemo = class
  public
    function GetApplication: TApplication; virtual; stdcall;
    procedure AddMenuItem(MenuItemCapt: String; Proc: TNotifyEvent); virtual; stdcall;
    procedure AddItem(Item: String); virtual;  stdcall;
  end;

  TPluginDemoForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Utilities1: TMenuItem;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    PInterface: TIPluginDemo;
    il:TList;
  public
    { Public declarations }
  end;

var
  PluginDemoForm: TPluginDemoForm;

implementation

{$R *.DFM}

type
  TInitPlugin = procedure(PlugClass: TIPluginDemo);

const
  PlugInitProc: PChar = 'InitPlugin';

function TIPluginDemo.GetApplication: TApplication;
begin
 Result:=Application;
end;

procedure TIPluginDemo.AddMenuItem(MenuItemCapt: String; Proc: TNotifyEvent);
var
 NewItem: TMenuItem;
begin
 NewItem:=TMenuItem.Create(PluginDemoForm);
 NewItem.Caption:=MenuItemCapt;
 NewItem.OnClick:=Proc;
 PluginDemoForm.Utilities1.Add(NewItem);
end;

procedure TIPluginDemo.AddItem(Item: String);
begin
 PluginDemoForm.Memo1.Lines.Add(Item);
end;

procedure TPluginDemoForm.FormCreate(Sender: TObject);
var
 PlugDir: String;
 Found, Attr: Integer;
 SearchRec: TSearchRec;
 PluginHandle: THandle;
 InitPlugin: TInitPlugin;
begin
 il:=TList.Create;
 PlugDir := ExtractFilePath(Application.ExeName) + 'PlugIns\';
 Attr := faReadOnly or faHidden or faSysFile or faArchive;
 Found := FindFirst(PlugDir+'*.DLL', Attr, SearchRec);
 while Found = 0 do
  begin
   try
    PluginHandle:=LoadLibrary(PChar(PlugDir+SearchRec.Name));
    @InitPlugin:=GetProcAddress(PluginHandle,PlugInitProc);
    if Longint(@InitPlugin)<>0 then
     begin
      try
       PInterface:=TIPluginDemo.Create;
       InitPlugin(PInterface);
       il.Add(PInterface);
      except
       raise Exception.Create(' !');
      end
     end
    else
     FreeLibrary(PluginHandle);
   except
    raise Exception.Create(' '+SearchRec.Name);
   end;
   Found := FindNext(SearchRec);
  end;
 FindClose(SearchRec);
end;

procedure TPluginDemoForm.Exit1Click(Sender: TObject);
begin
 Close;
end;

procedure TPluginDemoForm.FormDestroy(Sender: TObject);
begin
 il.Free;
end;

end.
